package org.olga.rebus.calculations;

import java.util.*;
import org.olga.rebus.structure.*;
import org.olga.rebus.structure.Rebus.*;

/**
 *      . 
 *       .
 * 
 * @author Olga
 *
 */
public class Result {

	//  
	private Collection myWords;
	// 
	private LinkedList<LinkedList<WordResult>> myResults;
	
	/**
	 *  .
	 * 
	 * @param words   .
	 */
	Result(Collection words) {
		myWords = words;
		myResults = new LinkedList<LinkedList<WordResult>>();
	}
	
	/**
	 * ,    .
	 * 
	 * @param ctx ,     .
	 */
	void add(Context ctx) {
		LinkedList<WordResult> list = new LinkedList<WordResult>();
		for (Object word: myWords) {
			VisibleWord word1 = (VisibleWord) word; 
			list.add(new WordResult(word1.getElement(), word1.getElement().getValue(ctx)));
		}
		myResults.add(list);
	}
	
	/**
	 * ,      .
	 * 
	 * @return  .
	 */
	Iterator<LinkedList<WordResult>> getResults() {
		return myResults.iterator();
	}
	
	/**
	 * ,    .
	 * 
	 * @return  .
	 */
	int getSize() {
		return myResults.size();
	}
	
	/**
	 *       .
	 * 
	 * @author Olga
	 *
	 */
	public static class WordResult {
		//
		private AbstractWord myWord;
		//
		private int myValue;
		
		/**
		 *  .
		 * 
		 * @param word 
		 * @param value  
		 */
		private WordResult(AbstractWord word, int value) {
			myWord = word;
			myValue = value;
		}
		
		/**
		 * ,  .
		 * 
		 * @return .
		 */
		public AbstractWord getElement() {
			return myWord;
		}
		
		/**
		 * ,   .
		 * 
		 * @return  .
		 */
		public int getValue() {
			return myValue;
		}
		
		/* (non-Javadoc)
		 * @see java.lang.Object#toString()
		 */
		public String toString() {
			return myWord.toString() + " " + myValue;
		}
	}
}
