package org.olga.rebus.gui;

import java.awt.*;
import java.util.Collection;

import javax.swing.JPanel;

import org.olga.rebus.structure.*;
import org.olga.rebus.structure.Rebus.*;

/**
 * -   .
 * 
 * @author Olga
 *
 */
class RebusViewPanel extends JPanel {
	private static final long serialVersionUID = 1L;
	//,    
	private RebusForm myFrame;
	
	/**
	 *  .
	 * 
	 * @param frame ,    
	 * 				 .
	 */
	public RebusViewPanel(RebusForm frame) {
		myFrame = frame;
		
		this.setPreferredSize(new Dimension(100, 100));
	}
	
	/*
	 * ,   .
	 */
	void setDimension() {
		IRebus rebus = myFrame.getRebus();
		int weigth = 0;
		int height = 0;
		for (VisibleWord word: rebus.getVisibleWords()) {
			int w = (word.getX() / 2 + word.getElement().toString().length()) * 18;
			int h = word.getY() * 9;
			if (weigth < w) {
				weigth = w;
			}
			if (height < h) {
				height = h;
			}
		}
		this.setPreferredSize(new Dimension(weigth, height + 15));
	}
	
	/* (non-Javadoc)
	 * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
	 */
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		IRebus rebus = myFrame.getRebus();
		int width = 0;
		int height = 0;
		if (rebus != null) {
			
			Font f = g.getFont();
			g.setColor(myFrame.myRebusColor);
			g.setFont(new Font(f.getName(), Font.BOLD, f.getSize()));
			
			Collection<VisibleWord> view = rebus.getVisibleWords();
			int maxX = 0;
			int maxY = 0;
			for (VisibleWord word: view) {
				int i = 0;
				for (AbstractSymbol s: word.getElement().getSymbols()) {
					int x = 5 + word.getX() * 15 / 2 + i * 15;
					int y = 15 + word.getY() * 18 / 2;
					if (maxX < x) {
						maxX = x;
					}
					if (maxY < y) {
						maxY = y;
					}
					g.drawString(s.toString(), x, y);
					i++;
				}
			}
			width = maxX + 10;
			height = maxY;
			
			Collection<VisibleLine> lines = rebus.getLines();
			if (lines != null) {
				for (VisibleLine l: lines) {
					int x1 = 10 + l.getX1() * 15 / 2;
					int y1 = 10 + l.getY1() * 18 / 2;
					int x2 = 10 + l.getX2() * 15 / 2;
					int y2 = 10 + l.getY2() * 18 / 2;
					g.drawLine(x1, y1, x2, y2);
				}
			}
			
			Collection<VisibleSign> signs = rebus.getSigns();
			
			for (VisibleSign c: signs) {
				int x = c.getX() * 15 / 2;
				int y = c.getY() * 18 / 2;
				if (c.getElement() == '*') {
					g.setFont(new Font(f.getName(), Font.BOLD, f.getSize() + 5));
					g.drawString(String.valueOf(c.getElement()), 5 + x, 20 + y);
					g.setFont(new Font(f.getName(), Font.BOLD, f.getSize()));
				} else {
					g.drawString(String.valueOf(c.getElement()), 5 + x, 15 + y);
				}
			}
		} 
		this.setPreferredSize(new Dimension(width + 15, height + 15));
	}
	
	/*
	 *   .
	 */
	public Dimension getPreferredScrollableViewportSize() {
		return getPreferredSize();
	}

	/*
	 *   .
	 */
	public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) {
		return getPreferredSize().height / 10;
	}

	/*
	 *   .
	 */
	public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction) {
		return getPreferredSize().height;
	}

	/*
	 *   .
	 */
	public boolean getScrollableTracksViewportWidth() {
		return false;
	}

	/*
	 *   .
	 */
	public boolean getScrollableTracksViewportHeight() {
		return false;
	}
}
