package org.olga.rebus.structure;

import org.olga.rebus.calculations.*;

/**
 *   .   AbstractWord.
 * 
 * @author Olga
 * @see AbstractWord
 *
 */
public class Word extends AbstractWord {

	// ,    .
	private AbstractSymbol[] myValue;
		
	/**
	 *  .
	 * 
	 * @param word  .
	 */
	Word(AbstractSymbol[] word) {
		myValue = word;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		for(int i=0; i < myValue.length; i++) {
			sb.append(myValue[i].toString());
		}
		return sb.toString();
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.words.AbstractWord#getValue(org.olga.rebus.Context)
	 */
	public int getValue(Context ctx) {
		int result = 0;
		for(int i=0; i < myValue.length; i++) {
			if (!(myValue[i] instanceof NumberSymbol)) {
				int value = ctx.getSymbolValue(myValue[i]);
				if (value != -1) {
					result += value * (int) Math.pow(10, myValue.length - i - 1);
				} else {
					return -1;
				}
			} else {
				result += ((NumberSymbol) myValue[i]).getValue() * (int) Math.pow(10, myValue.length - i - 1);
			}
		}
		/*if (result == 0) {
			return -1;
		}*/
		return result;
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.words.AbstractWord#getSymbol(int)
	 */
	public AbstractSymbol getSymbol(int index) {
		return myValue[index];
	}
	
	/* (non-Javadoc)
	 * @see org.olga.rebus.structure.words.AbstractWord#getLength()
	 */
	public int getLength() {
		return myValue.length;
	}
	
	public AbstractSymbol[] getSymbols() {
		return myValue;
	}
}
